/*
 * AdabasPort.c --
 *
 *
 * This file contains procedures, that are neccessary only on some specific
 * architectures. It also has some procs that make it possible, to use
 * the new (from version 8.0 upward) object commands of Tcl, even
 * with a Tcl version, that is older.
 *
 * Copyright (c) 1996-1997 Christian Krone. All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the same terms as Tcl itself.
 * See also licence.terms
 *
 * $Id: AdabasPort.c,v 1.1 1997/01/01 21:50:07 adabas Exp $
 */

#include <tcl.h>
#include "AdabasPort.h"

#ifndef HAS_TCL_OBJECTS

int
GetIntFromObj (interp, obj, longPtr)
     Tcl_Interp *interp;		/* Current interpreter. */
     Tcl_Obj    *obj;			/* Object to get int from. */
     long       *longPtr;		/* Long, to store result into. */
{
  int intRes;

  if (Tcl_GetInt (interp, obj, &intRes) == TCL_ERROR) {
    return TCL_ERROR;
  }
  *longPtr = intRes;
  return TCL_OK;
}

int
SetIntResult (interp, val)
     Tcl_Interp *interp;		/* Current interpreter. */
     long        val;			/* number to set as result. */
{
  char numBuf[80];

  sprintf (numBuf, "%ld", val);
  Tcl_ResetObjResult (interp);
  AppendResult (interp, numBuf);
  return TCL_OK;
}

#endif /* HAS_TCL_OBJECTS */
